import pygame
from image import im
from sound import sm
from actor import Actor
from atropos import Atropos

class PlayState:

	def __init__(self,level,path):
		self.level = level
		self.back = im.get("lvl%i.png"%level)
		self.HUD = im.get("playHUD.png")
		self.buttons = [(pygame.Rect(14,526,30,20),self.stop),
						(pygame.Rect(65,526,30,20),self.pause),]
		self.time = 0
		self.paused = False
		self.mask = False
		self.stopNow = False
		self.path = path[:]
		self.clickTimeout = 15
		self.load(level,path)
	
	def load(self,level,path):
		lvl = __import__("level%i"%level,globals())
		self.guys = lvl.loadGuys()[:]
		self.atropos = Atropos(lvl.atroposPos,path)
	
	def stop(self):
		self.stopNow = True
		
	def pause(self):
		self.paused = not self.paused
	
	def togMask(self):
		self.mask = not self.mask
	
	def tick(self):
		if self.stopNow:
			from planstate import PlanState
			return PlanState(self.level,self.path)
		if not self.paused:
			[g.tick() for g in self.guys]
			self.atropos.tick(self.guys,self.time)
			self.time += 1
			
			win = True
			for ok in [g.timelyDeath for g in self.guys]:
				if not ok:
					win = False
					break
			if win:
				from planstate import PlanState
				sm.play("yay.ogg")
				return PlanState(self.level+1)
		
		if self.clickTimeout:
			self.clickTimeout -= 1
		
		if not self.clickTimeout and pygame.mouse.get_pressed()[0]:
			self.clickTimeout = 15
			pos = pygame.mouse.get_pos()
			for b in self.buttons:
				if b[0].collidepoint(pos):
					b[1]()
		return self
	
	def render(self,screen):
		screen.blit(self.back,(0,0))
		[g.render(screen) for g in self.guys]
		self.atropos.render(screen)
		screen.blit(self.HUD,(0,0))
		screen.blit(im.get("strings%i.png"%self.level),(250,510))
		x = 300 + self.time/5
		pygame.draw.line(screen,0xff0000,(x,510),(x,590))
		if self.mask:
			n0 = None
			for node in self.path:
				pygame.draw.circle(screen,0x00ffff,node,4)
				if n0:
					pygame.draw.line(screen,(255,0,0),n0,node)
				n0 = node